<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { computed, ref } from 'vue';
import { useScheduleStore } from '@/stores/schedule';
import Modal from '@/components/general/Modal.vue';
import TextEditor from '@/components/general/form/TextEditor.vue';
import { textClear } from '@/lib/utils';

const props = defineProps<{
    text?: string,
    columnIndex?: number
}>();

const emits = defineEmits<{
    (e: 'close'):void
}>();

const store = useScheduleStore();

const content = ref(props.text!==undefined?props.text:'');

const cancel = ()=>{
    emits('close');
}

const submit = ()=>{
    if(props.columnIndex===undefined){
        store.createColumn({text: content.value});
    }else if(props.columnIndex!==undefined){
        store.editColumnProps({columnIndex: props.columnIndex, text: content.value});
    }
    cancel();
}

const disable = computed(()=>{
    return textClear(content.value).length==0;
});

</script>
<template>
<Modal :header="columnIndex!==undefined?$t('contentPage.column.edit'):$t('contentPage.column.add')" :labelCancel="$t('general.buttons.cancel')" :labelSubmit="columnIndex!==undefined ?$t('contentPage.editSubmit'):$t('contentPage.addSubmit')" @close="cancel" @submit="submit" :font="store.getStyle?.font?store.getStyle.font:''" :disableSubmit="disable">
    <div class="mt-2">
        <label>{{$t("contentPage.column.content")}}</label>
        <div class="border border-gray-300 rounded-md p-1">
            <TextEditor v-model="content" :hide-buttons="true" :hide-list-buttons="true"/>
        </div>
    </div>
</Modal>
</template>